var Pullup = require("../../index");
var BigNumber = require("bignumber.js");
var abi = require("./SRC20-ABI");
var data = require("./SRC20-data");
var serojs = require("serojs");

var pullup = new Pullup();

pullup.setProvider(new pullup.providers.HttpProvider('http://localhost:2345/rpc'));


// ========== test SRC20 Token packConstructResult
// var _totalSupply = "0x" + new BigNumber(10000).toString(16);
// var _tokenDecimals = "0x" + new BigNumber(18).toString(16);
// var _tokenSymbol = "S_TEST";
// var _tokenName = "S_TEST";
// var args = [_totalSupply, _tokenName, _tokenSymbol.toUpperCase(), _tokenDecimals];
//
// var packConstructResult = pullup.sero.packConstruct(abi, data.data, args);
//
// console.log("packConstructResult: ", packConstructResult);


// ========== test SRC20 Token packMethod
var from = "56k6dtdD4uhx4L45jNCGpiXmbMUuEPm1c3Y1cnYJx8y17buxNi7JuFPUaqKmBr7cExPmxqurLs3cPoSMPspkDqge";
var methods = [ "name","symbol", "totalSupply", "balanceOf", "decimals"];
var contractAddress = "UFsgesDBcSNhHVj8pPspPE3iBmigMcU95U2ZK892GBHgkwGyYebGueTJjD8MAs9ZqLT2EhvSsmdWHZ3iSJLsFEY";
var args = [];


console.log("====================== Result SEROJS Begin ==========================");
var contract = serojs.callContract(abi,contractAddress)
for (let method of methods) {
    console.log(method, " = ", execute(contract, method, []));
}
console.log("====================== Result SEROJS End ==========================");

/**
 *
 ====================== Result SEROJS Begin ==========================
 name  =  SLS
 symbol  =  JSLSJD
 totalSupply  =  BigNumber { s: 1, e: 21, c: [ 10000000 ] }
 balanceOf  =  BigNumber { s: 1, e: 20, c: [ 9900000 ] }
 decimals  =  BigNumber { s: 1, e: 1, c: [ 19 ] }
 ====================== Result SEROJS End ==========================
 */

function execute(contract,method,args) {
    var packData = contract.packData(method,args);
    var callParams = {
        from: from,
        to: contractAddress,
        data: packData
    }
    var callData = pullup.sero.call(callParams,"latest");
    if (callData !== "0x"){
        var res = contract.unPackData(method,callData);
        return res;
    }
    return "";
}


// console.log("====================== Result RPC Begin ==========================");
// for (let method of methods) {
//     console.log(method, " = ", executeRPC(contractAddress, method, args));
// }
// console.log("====================== Result RPC End ==========================");


/**
 ====================== Result ==========================
 name  =  [ 'SLS' ]
 symbol  =  [ 'JSLSJD' ]
 totalSupply  =  [ 1e+21 ]
 balanceOf  =  [ 990000000000000000000 ]
 decimals  =  [ 19 ]
 ====================== Result ==========================
 */

// gero rpc pack data, unused
// function executeRPC(contractAddress, methodName, args) {
//     var packMethodData = pullup.sero.packMethod(abi, contractAddress, methodName, args);
//     var callParams = {
//         from: from,
//         to: contractAddress,
//         data: packMethodData
//     }
//     var callData = pullup.sero.call(callParams,"latest");
//     var packMethodData = pullup.sero.unPack(abi, methodName, callData);
//     return packMethodData
// }

